/**
 * This is the applet that is contained in a html page<br>
 * It only contains a button that starts the actual interface.
 *
 * @author Hans Stenten
 * @author Filip Van Rysselberghe
 */

package project;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class AlgAnimatorApplet extends Applet
{
	public Button fStartButton;
		
	/**
     * Standard method of the Applet api that
     * will provide information about the parameters
     * used by the applet
     */
	public String[][] getParameterInfo()
	{
		return null;
	}

	/**
     * Another standard method used in providing
     * information about the applet.
     */
	public String getAppletInfo()
	{
		return "Applet Information";
	}

	/**
     * Initialize the applet
     */
	public void init()
	{
		try {
			//If you want to use the applet in a page with another
			//background color then you have to change the following line
			setBackground( Color.white );
			
			//If you don't like the title of our project then change the
			//startbutton 's caption into your awn favorite
			fStartButton = new Button("Start Algorithms In Action");
			add(fStartButton);
			
			setSize(new java.awt.Dimension(200, 50));
			validate();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
     * Like in every applet the action-function provides the eventhandling.
     * In our case it handles the pressing of the StartButton. When a user
     * pushes the button the frame will be launched. And the original start-
     * button disabled so that the user can't start the program twice.
     *
     * @see AlgAnimatorFrame
     */
        public boolean action(Event e, Object arg){
		Object target = e.target;

		if (target == fStartButton){
			fStartButton.disable();
			new AlgAnimatorFrame(this);
			return true;
		}
		return false;
	}


}
