package project;

/**
 *	AlgThread is a class containing all elements needed for the
 *	implementation of an algorithm.
 *	It contains a link to the containing frame. This class has to be
 *	derived and implemented to be usefull.
 *	Further is AlgThread an extension of Thread, so is runnable as a
 *	Thread.
 *
 *	@author			Hans Stenten
 *	@author			Filip Van Rysselberghe
 *
 *	@version		1.10, 04/11/2000
 */
import java.awt.*;
import java.io.*;
import java.lang.*;
import java.util.Random;

public abstract class AlgThread extends Thread{

	protected ImagesThread fImages;

	protected AlgAnimatorConfig fConfig;

	/**
	 *	Constructor, sets the parent, the configuration and falsifies
	 *	the stepping
	 *
	 *	@author			Filip Van Rysselberghe
	 *	@param			parent		the frame containing
	 *												the Thread
	 */
	protected AlgThread(ImagesThread images, AlgAnimatorConfig config) {
                System.err.println("AlgThread in");
		fImages = images;
		fConfig = config;
                System.err.println("AlgThread out");
	}
	
	/**
	 *	Function that will be called when a running algorithm has to be
	 *	stopped. Most of the time this only means the stopping of
	 *	the algoritm thread. But some algorithms have some clean-up to 
	 *	perform before stopping the thread. So they can overload this function
	 *	with their specific handling.
	 */
	public void stopAlgorithm() {
		this.stop();
	}
}
