package project;

/**
 *
 *	BinarySearchAlgThread extends SearchAlgThread
 *	with an binary search implementation.
 *
 *	@author			Hans Stenten
 *	@author			Filip Van Rysselberghe
 *	@version		1.10, 12/03/2001
 */
import java.awt.*;
import java.io.*;
import java.lang.*;

public class BinarysearchAlgThread extends SearchAlgThread {

	/**
	 *	Constructor
	 *	just calls constructor of SearchAlgThread
	 *
	 *	@author			Filip Van Rysselberghe
	 *	@param			images  provides the images to draw on (animation, text, status)
         *      @param                  config  the configuration of the application
         *      @see                    ImagesThread
         *      @see                    AlgAnimatorConfig
	 */
        public BinarysearchAlgThread(ImagesThread images, AlgAnimatorConfig config) {
                super(images, config);
        }

	/**
	 *	java version of the binary search algorithm as can be found in the course "Fundamenten van de Informatica" by
	 *	Prof. E Laenens.
	 *	binSearch is the actual search function, it is a binary search implementation.
	 *	To animate the algorithm the animate functions of the drawer class is called
	 *
	 *	@author			Hans Stenten
	 *	@param			first	the upperbound of the array-part to be sorted this run
	 *	@param			last	the lowerbound of the array-part to be sorted this run
	 */
        private void binSearch(int value, int first, int last) throws InterruptedException{
                fTextDraw.animate(0, false);	// PROCEDURE binSearch
                fTextDraw.animate(1, false);	// VAR middle: INTEGER;
                int middle;
                fTextDraw.animate(2, false);	// BEGIN
                middle = (first + last) / 2;
                fStatusDraw.animate(new String[]{"middle :\t"+middle, "first :\t"+first, "last :\t"+last}, fPass);
                fTextDraw.animate(3, false);	// middle:= (first+last) DIV 2;
                fAnimDraw.animate(middle);
                fTextDraw.animate(4, false);	// IF (first <= last) THEN
                if (first <= last){
                        fTextDraw.animate(4, true); // IF (first <= last) THEN
                        // searching
                        // found
                        ++fPass;
                        fStatusDraw.animate(new String[]{"value :\t\t"+value, "itemsToSearch["+middle+"] :\t"+fItemsToSearch.getValue(middle)}, fPass);
                        fTextDraw.animate(6, false); // IF (value = itemsToSearch[middle]) THEN
                        if (value == fItemsToSearch.getValue(middle)){
                                fTextDraw.animate(6, true); // IF (value = itemsToSearch[middle]) THEN
                                fTextDraw.animate(7, false); // return middle
                                fStatusDraw.animate(new String[]{"Value ("+value+") found in itemsToSearch["+middle+"]\n"}, fPass);
                                return;
                        }
                        // search left
                        else if (value < fItemsToSearch.getValue(middle)){
                                fTextDraw.animate(10, true); // IF (value < itemsToSearch[middle]) THEN
                                fTextDraw.animate(11, false); // binSearch(itemsToSearch, value, first, middle-1);
                                binSearch(value, first, middle-1);
                        }
                        // search right
                        else if (value > fItemsToSearch.getValue(middle)){
                                fTextDraw.animate(10, false); // IF (value < itemsToSearch[middle]) THEN
                                fTextDraw.animate(14, false); // IF (value > itemsToSearch[middle]) THEN
                                fTextDraw.animate(14, true); // IF (value > itemsToSearch[middle]) THEN
                                fTextDraw.animate(15, false); // binSearch(itemsToSearch, value, middle+1, last);
                                binSearch(value, middle+1, last);
                        }
                }
                else{
                        // not found
                        fTextDraw.animate(17, true); // ELSE
                        fStatusDraw.animate(new String[]{"Value ("+value+") not found in itemsToSearch\n"}, fPass);
                        return;
                }
        }

	/**
	 *	calls quickSort()
	 *
	 *	@author			Hans Stenten
         *      @param                  value the value to search for in the list
	 */
        public void search(int value) throws java.lang.Exception {
                binSearch(value, 0, fItemsToSearch.length() - 1);
                fConfig.setRunning(false);
        }
}