package project;

/**
 *
 *	BubblesortAlgThread extends SortAlgThread
 *	with an bubblesort implementation.
 *
 *	@author			Hans Stenten
 *	@author			Filip Van Rysselberghe
 *	@version		1.10, 04/11/2000
 */
import java.awt.*;
import java.io.*;
import java.lang.*;

public class BubblesortAlgThread extends SortAlgThread{
	/**
	 *	Constructor
	 *	just calls constructor of SortAlgThread
	 *
	 *	@author			Filip Van Rysselberghe
	 *	@param			images  provides the images to draw on (animation, text, status)
         *      @param                  config  the configuration of the application
         *      @see                    ImagesThread
         *      @see                    AlgAnimatorConfig
	 */
	public BubblesortAlgThread(ImagesThread images, AlgAnimatorConfig config){
		super(images, config);
                System.err.println("Bubblesort in");
                System.err.println("Bubblesort out");
	}

	/**
	 *
	 *	public void sort()
	 *	java version of the bubblesort algorithm as can be found in the course "Fundamenten van de Informatica" by
	 *	Prof. E Laenens.
	 *	it is a bubble sort implementation.
	 *	The animation of the algorithm is handled through the animate method
	 *	of the drawer class.
	 *
	 *	@author			Hans Stenten
	 *	@author			Filip Van Rysselberghe
	 */
	public void sort() throws InterruptedException {
		fTextDraw.animate(0, false);	// PROCEDURE bubblesort
						//
		fTextDraw.animate(2, false);	// VAR 	exchanges : BOOLEAN;
		fTextDraw.animate(3, false);	// 	j, temp : INTEGER;
						//
		fTextDraw.animate(5, false);	// BEGIN

		boolean exchanges = true;
		fTextDraw.animate(6, false);	// exchanges := TRUE

		fStatusDraw.animate(new String[]{"exchanges : " + exchanges}, fPass);

		int j = 0;

		fTextDraw.animate(7, false);		// WHILE --> not yet taken
		while (exchanges) {
			fTextDraw.animate(7,true);	// WHILE --> taken

			exchanges = false;
			fTextDraw.animate(8, false);	// exchanges := FALSE
			fStatusDraw.animate(new String[]{"exchanges : " + exchanges}, fPass);

			fTextDraw.animate(9, false);	// FOR --> not yet taken
			fStatusDraw.animate(new String[]{"j :\t\t"+j, "LEN(fItemsToSort) :\t"+fItemsToSort.length()}, fPass);
			for (j = 0; j < ((fItemsToSort.length()) - 1); ++j ) {
				fStatusDraw.animate(new String[]{"j :\t\t"+j, "LEN(fItemsToSort) :\t"+fItemsToSort.length()}, fPass);

				fTextDraw.animate(9, true);	// FOR --> taken

				fTextDraw.animate(10, false);	//IF --> not yet taken
              			fAnimDraw.animate(j,j+1, false);

				fStatusDraw.animate(new String[]{"itemsToSort["+j+"] :\t"+fItemsToSort.getValue(j), "itemsToSort["+(j+1)+"] :\t"+fItemsToSort.getValue(j+1)}, fPass);
				if ( fItemsToSort.getValue(j) > fItemsToSort.getValue(j+1) ) {

					fTextDraw.animate(10, true);	//IF --> taken

					fAnimDraw.animate(j, j+1, true);

					swap(j, j+1);
                                        ++fPass;
					fTextDraw.animate(11, false);	// (* swap *)
					fTextDraw.animate(12, false);	// temp :=
					fTextDraw.animate(13, false);	// itemsToSort[j] :=
					fTextDraw.animate(14, false);	// itemsToSort[j+1] :=

					fAnimDraw.animate(j, j+1, true);
                                        fStatusDraw.animate(new String[]{"itemsToSort["+j+"] :\t"+fItemsToSort.getValue(j), "itemsToSort["+(j+1)+"] :\t"+fItemsToSort.getValue(j+1)}, fPass);

					exchanges = true;
					fTextDraw.animate(15, false);	// exchanges := TRUE
					fStatusDraw.animate(new String[]{"exchanges : "+exchanges}, fPass);
				}
				fTextDraw.animate(16, false);	//END IF

				//fAnimDraw.animate(j, j+1, false);

			}
			fTextDraw.animate(17, false);	//END FOR
		}

		fTextDraw.animate(18, false);	//END WHILE
		fTextDraw.animate(19, false);	//END PROCEDURE
                fStatusDraw.animate(new String[]{"Items sorted in "+fPass+""}, fPass);
                fConfig.setRunning(false);
	}
}
