package project;

import java.awt.*;
import java.awt.event.*;


/**
 *	Control Panel is the panel containing all the controlbuttons for
 *	showing an animated algorithm. Like you probably guessed there are
 *	buttons to start an algorithm, stop it. Meaby a little less logical
 *	are a button to fire up the configuration-screen and a button to
 *	animate an algorithm step by step.
 *
 *	@author Hans Stenten
 *
 */
public class ControlPanel extends Panel {
	private AlgAnimatorFrame fParent;
	private AlgAnimatorConfig fConfig;
        private AlgAnimatorDialog fDialog;

        Button fStartButton = new Button();
        Button fStopButton = new Button();
        Button fStepButton = new Button();
        Button fConfigButton = new Button();

        /**
         * BOGUS JUST TO MANIPULATE IT GRAPHICALLY IN JBUILDER
         */
        public ControlPanel() {
                try {
                        jbInit();
                }
                catch(Exception e) {
                        e.printStackTrace();
                }
        }

	/**
	 *  Constructor
	 *  @param config the configuration of the frame @see AlgAnimatorConfig
         *  @param parent the parent frame
	 */
        public ControlPanel(AlgAnimatorFrame parent, AlgAnimatorConfig config) {
                fParent = parent;
		fConfig = config;
		fDialog = new AlgAnimatorDialog(fParent, "Algorithms in Action - Configuration", config);
                try {
                        jbInit();
                }
                catch(Exception e) {
                        e.printStackTrace();
                }
                fStartButton.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e){
				fParent.startAlgorithm();
				fStartButton.setEnabled(true);
			}
		});

		fConfigButton.addActionListener(new ActionListener() {
                      public void actionPerformed(ActionEvent e) {
                                fDialog.setVisible(true);
                      }
                });

		fStopButton.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e){
				fParent.stopAlgorithm();
				fStartButton.setEnabled(true);
			}
		});

		fStepButton.addMouseListener(new MouseAdapter(){
			public void mouseClicked(MouseEvent e){
				fParent.stepAlgorithm();
				fStartButton.setEnabled(true);
			}
		});
        }


        /**
         * Initiates all components
         *
         * @author Hans Stenten
         */
        private void jbInit() throws Exception {
                setBackground( Color.lightGray );
                fStartButton.setLabel("Run");
                fStopButton.setLabel("Stop");
                fStepButton.setLabel("Step");
                fConfigButton.setLabel("Config");
                this.add(fStartButton);
                this.add(fStopButton);
                this.add(fStepButton);
                this.add(fConfigButton);
        }

        /**
         * Re-enable startbutton
         *
         * @author Hans Stenten
         */
        public void activateStart(){
                fStartButton.setEnabled(true);
        }
}