package project;

/**
 *	InsertionsortAlgThread extends SortAlgThread
 *	with an insertionsort implementation.
 *
 *	@author			Hans Stenten
 *	@version		1.10, 04/11/2000
 */
import java.awt.*;
import java.io.*;
import java.lang.*;

public class InsertionsortAlgThread extends SortAlgThread{
	/**
	 *	Constructor
	 *	just calls constructor of SortAlgThread
	 *
	 *	@author			Hans Stenten
	 *	@param			images  provides the images to draw on (animation, text, status)
         *      @param                  config  the configuration of the application
         *      @see                    ImagesThread
         *      @see                    AlgAnimatorConfig
	 */
	public InsertionsortAlgThread(ImagesThread images, AlgAnimatorConfig config){
		super(images, config);
	}

	/**
	 *	An insertion sort implementation.
	 *	Calls the animate function of the SortAlgThreadDrawer to
	 *	animate the algorithm.
	 *
	 *	@author			Hans Stenten
	 */
	public void sort() throws InterruptedException {
		fAnimDraw.animate(-1,-1,false);

		fTextDraw.animate(0, false);	// PROCEDURE insertionsort
						//
		fTextDraw.animate(2, false);	// VAR i,j,temp : INTEGER;
						//
		fTextDraw.animate(4, false);	// BEGIN

		fTextDraw.animate(5, false);	// FOR --> not yet taken
		for (int i = 1; i < fItemsToSort.length(); ++i) {
                        fStatusDraw.animate(new String[]{"i :\t\t"+i, "LEN(itemsToSort) :\t"+fItemsToSort.length()}, fPass);
			fTextDraw.animate(5, true);	// FOR --> taken

	            	int j = i;
                        fStatusDraw.animate(new String[]{"j :\t\t"+j}, fPass);
	    	        fTextDraw.animate(6, false);	// j := i

        		int B = fItemsToSort.getValue(i);
	        	fTextDraw.animate(7, false);		// temp :=
                        fStatusDraw.animate(new String[]{"j :\t\t"+j, "temp :\t\t"+B}, fPass);
			fAnimDraw.animate(i, -1, false);

		        fTextDraw.animate(8, false);	// WHILE --> not yet taken
			fAnimDraw.animate(i, (j-1), false);
			while ((j > 0) && (fItemsToSort.getValue(j-1) > B)) {
                                fStatusDraw.animate(new String[]{"j :\t\t"+j, "temp :\t\t"+B, "itemsToSort["+(j-1)+"] :\t"+fItemsToSort.getValue(j-1)}, fPass);
		    	        fTextDraw.animate(8, true);	// WHILE --> taken
				fAnimDraw.animate(j,j-1,false);

        		        fItemsToSort.setValue(j, fItemsToSort.getValue(j-1));
                                ++fPass;
	        	        fTextDraw.animate(9, false);	// itemsToSort[j] :=
                                fStatusDraw.animate(new String[]{"j :\t\t"+j, "temp :\t\t"+B, "itemsToSort["+(j)+"] :\t"+fItemsToSort.getValue(j)}, fPass);

				fItemsToSort.setValue(j-1, B);
				fTextDraw.animate(10, false);
	                        fStatusDraw.animate(new String[]{"j :\t\t"+j,"temp :\t\t"+B, "itemsToSort["+(j)+"] :\t"+fItemsToSort.getValue(j)}, fPass);
				fAnimDraw.animate(j-1, j, false);

		                --j;
        		        fTextDraw.animate(11, false);	// DEC(j)
                        }
                        fTextDraw.animate(12, false);	// END WHILE
			fAnimDraw.animate(i,-1, false);
		}
		fTextDraw.animate(13, false);	// END FOR
		fTextDraw.animate(14, false);	// END PROCEDURE

		fStatusDraw.animate(new String[]{"Items sorted in "+fPass+""}, fPass);
                fConfig.setRunning(false);
    }
}
