package project;

/**
 *
 *	SequentialsearchAlgThread extends SearchAlgThread
 *	with an sequential search implementation.
 *
 *	@author			Hans Stenten
 *	@author			Filip Van Rysselberghe
 *	@version		1.10, 12/03/2001
 */
import java.awt.*;
import java.io.*;
import java.lang.*;

public class SequentialsearchAlgThread extends SearchAlgThread {

	/**
	 *	Constructor
	 *	just calls constructor of SearchAlgThread
	 *
	 *	@author			Filip Van Rysselberghe
	 *	@param			images  provides the images to draw on (animation, text, status)
         *      @param                  config  the configuration of the application
         *      @see                    ImagesThread
         *      @see                    AlgAnimatorConfig
	 */
        public SequentialsearchAlgThread(ImagesThread images, AlgAnimatorConfig config) {
                super(images, config);
        }

	/**
	 *	Java implementation of an sequantial searching algorithm
	 *
	 *	@author			Hans Stenten
         *      @param                  value the value to search for in the list
	 */
        public void search(int value) throws java.lang.Exception {
                fTextDraw.animate(0, false);	// PROCEDURE seqSearch
                fTextDraw.animate(1, false);	// VAR i : INTEGER;
                int i;
                fTextDraw.animate(2, false);	// BEGIN
                fTextDraw.animate(3, false);    // FOR j := 0 TO ( LEN(itemsToSearch) - 1 ) DO
                for (i = 0; i < fItemsToSearch.length(); ++i){
                        ++fPass;
                        fStatusDraw.animate(new String[]{"i :\t\t\t"+i, "LEN(itemsToSearch) - 1 :\t"+(fItemsToSearch.length()-1)}, fPass);
                        fTextDraw.animate(3, true);    // FOR j := 0 TO ( LEN(itemsToSearch) - 1 ) DO
                        fAnimDraw.animate(i);
                        fStatusDraw.animate(new String[]{"value :\t\t"+value, "itemsToSort["+i+"] :\t"+fItemsToSearch.getValue(i)}, fPass);
                        fTextDraw.animate(4, false);    // IF (itemsToSort[i] = value) THEN
                        if (value == fItemsToSearch.getValue(i)){
                                fTextDraw.animate(4, true);    // IF (itemsToSearch[i] = value) THEN
                                fTextDraw.animate(5, false);    // RETURN i;
                                fStatusDraw.animate(new String[]{"Value ("+value+") found in itemsToSearch["+i+"]\n"}, fPass);
                                return;
                        }
                }
                fTextDraw.animate(8, false);    // RETURN -1;
                fStatusDraw.animate(new String[]{"Value ("+value+") not found in itemsToSearch\n"}, fPass);
                fConfig.setRunning(false);
        }
}