package project;

import java.awt.*;
import java.awt.event.*;

/**
 * This panel is used to explain the different steps of the algorithm,
 * a sort of log of the steps is contained in the textarea. Some other
 * basic parameters of the algorithm are also displayed. The algorithm name,
 * the number of passes of the algorithm, and the search value.
 *
 * @author Hans Stenten
 */


public class StatusPanel extends Panel {
        BorderLayout borderLayout1 = new BorderLayout();
        Panel statusCommands = new Panel();
        Button statusClear = new Button();
        BorderLayout borderLayout2 = new BorderLayout();
        Panel statusHeader = new Panel();
        public Label statusPass = new Label();
        public Label statusTitle = new Label();
        public Label statusSearch = new Label();
        public TextArea statusArea = new TextArea();
        GridLayout gridLayout1 = new GridLayout();

        /**
         * Constructor
         *
         * @author Hans Stenten
         */
        public StatusPanel() {
                try {
                        jbInit();
                }
                catch(Exception e) {
                        e.printStackTrace();
                }
        }

        /**
         * Initiates the components
         *
         * @author Hans Stenten
         */
        private void jbInit() throws Exception {
                this.setLayout(borderLayout1);
                statusClear.setLabel("clear");
                statusClear.addMouseListener(new java.awt.event.MouseAdapter() {
                        public void mouseClicked(MouseEvent e) {
                                statusClear_mouseClicked(e);
                        }
                });
                statusCommands.setLayout(borderLayout2);
                statusCommands.setBackground(Color.lightGray);
                statusPass.setAlignment(2);
                statusPass.setText("             ");
                statusHeader.setLayout(gridLayout1);
                statusHeader.setBackground(Color.lightGray);
                statusSearch.setAlignment(1);
                statusSearch.setText("              ");
                statusTitle.setText("                ");
                statusHeader.add(statusTitle, null);
                statusHeader.add(statusSearch, null);
                statusHeader.add(statusPass, null);
                statusCommands.add(statusClear, BorderLayout.EAST);
                this.add(statusHeader, BorderLayout.NORTH);
                this.add(statusArea, BorderLayout.CENTER);
                this.add(statusCommands, BorderLayout.SOUTH);
        }

        /**
         * The preferred size of the panel
         *
         * @author Hans Stenten
         */
        public Dimension preferredSize() {
		return new Dimension(345, 150);
	}

        /**
         * Clear the textarea when the clean button is cleared
         *
         * @author Hans Stenten
         */
        void statusClear_mouseClicked(MouseEvent e) {
                statusArea.setText("");
        }
}